'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _lodash = require('lodash');

var _arrToConnection = require('./arrToConnection');

var _arrToConnection2 = _interopRequireDefault(_arrToConnection);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = (() => {
  var _ref = _asyncToGenerator(function* (sqlAST, data, dbCall, context, options) {
    if (sqlAST.paginate) {
      if (Array.isArray(data)) {
        data = (0, _lodash.chain)(data).flatMap('edges').map('node').value();
      } else {
        data = (0, _lodash.map)(data.edges, 'node');
      }
    }
    if (!data || Array.isArray(data) && data.length === 0) {
      return;
    }

    return Promise.all(sqlAST.children.map((() => {
      var _ref2 = _asyncToGenerator(function* (childAST) {
        if (childAST.type === 'table') {
          const fieldName = childAST.fieldName;

          if (childAST.sqlBatch || childAST.junctionBatch) {
            let thisField, parentField;
            if (childAST.sqlBatch) {
              childAST.children.push(childAST.sqlBatch.thisKey);
              thisField = childAST.sqlBatch.thisKey.fieldName;
              parentField = childAST.sqlBatch.parentKey.fieldName;
            } else if (childAST.junctionBatch) {
              childAST.children.push(childAST.junctionBatch.thisKey);
              thisField = childAST.junctionBatch.thisKey.fieldName;
              parentField = childAST.junctionBatch.parentKey.fieldName;
            }
            if (Array.isArray(data)) {
              const batchScope = (0, _lodash.uniq)(data.map(function (obj) {
                return (0, _util.maybeQuote)(obj[parentField]);
              }));
              const { sql, shapeDefinition } = yield (0, _util.compileSqlAST)(childAST, context, _extends({}, options, { batchScope }));
              let newData = yield (0, _util.handleUserDbCall)(dbCall, sql, (0, _util.wrap)(shapeDefinition));
              newData = (0, _lodash.groupBy)(newData, thisField);
              if (childAST.paginate) {
                (0, _lodash.forIn)(newData, function (group, key, obj) {
                  obj[key] = (0, _arrToConnection2.default)(group, childAST);
                });
              }
              if (childAST.grabMany) {
                for (let obj of data) {
                  obj[fieldName] = newData[obj[parentField]] || [];
                }
              } else {
                for (let obj of data) {
                  obj[fieldName] = (0, _arrToConnection2.default)(newData[obj[parentField]][0], childAST);
                }
              }
              const nextLevelData = (0, _lodash.flatMap)(data, function (obj) {
                return obj[fieldName];
              });
              return nextBatch(childAST, nextLevelData, dbCall, context, options);
            } else {
              const batchScope = [data[parentField]];
              const { sql, shapeDefinition } = yield (0, _util.compileSqlAST)(childAST, context, _extends({}, options, { batchScope }));
              let newData = yield (0, _util.handleUserDbCall)(dbCall, sql, (0, _util.wrap)(shapeDefinition));
              newData = (0, _lodash.groupBy)(newData, thisField);
              if (childAST.paginate) {
                const targets = newData[data[parentField]];
                data[fieldName] = (0, _arrToConnection2.default)(targets, childAST);
              } else {
                if (childAST.grabMany) {
                  data[fieldName] = newData[data[parentField]] || [];
                } else {
                  const targets = newData[data[parentField]] || [];
                  data[fieldName] = targets[0];
                }
              }
              return nextBatch(childAST, data[fieldName], dbCall, context, options);
            }
          } else {
            if (Array.isArray(data)) {
              const nextLevelData = (0, _lodash.flatMap)(data, function (obj) {
                return obj[fieldName];
              });
              return nextBatch(childAST, nextLevelData, dbCall, context, options);
            } else {
              if (data) {
                return nextBatch(childAST, data[fieldName], dbCall, context, options);
              }
            }
          }
        }
      });

      return function (_x6) {
        return _ref2.apply(this, arguments);
      };
    })()));
  });

  function nextBatch(_x, _x2, _x3, _x4, _x5) {
    return _ref.apply(this, arguments);
  }

  return nextBatch;
})();